﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Runtime.CompilerServices;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace ComboBox_Sample
{
   public partial class MainPage : ContentPage
   {
      EmployeeViewModel employeeViewModel = new EmployeeViewModel();
      public MainPage()
      {
         InitializeComponent();
         this.BindingContext = employeeViewModel;
      }

      private void Button_Clicked(object sender, EventArgs e)
      {
         employeeViewModel.EmployeeCollection.Clear();
         employeeViewModel.EmployeeCollection = new ObservableCollection<Employee>();
         employeeViewModel.EmployeeCollection.Add(new Employee() { ID = 1, Name = "Frank1" });
         employeeViewModel.EmployeeCollection.Add(new Employee() { ID = 2, Name = "James2" });
         employeeViewModel.EmployeeCollection.Add(new Employee() { ID = 3, Name = "Steve3" });
         employeeViewModel.EmployeeCollection.Add(new Employee() { ID = 4, Name = "Lucas4" });
         employeeViewModel.EmployeeCollection.Add(new Employee() { ID = 5, Name = "Mark5" });
         employeeViewModel.EmployeeCollection.Add(new Employee() { ID = 6, Name = "Michael6" });
         employeeViewModel.EmployeeCollection.Add(new Employee() { ID = 7, Name = "Aldrin7" });
         employeeViewModel.EmployeeCollection.Add(new Employee() { ID = 8, Name = "Jack8" });
         employeeViewModel.EmployeeCollection.Add(new Employee() { ID = 9, Name = "Howard9" });
         employeeViewModel.SelectedItem = employeeViewModel.EmployeeCollection[3];
      }
      private void Button_Clicked2(object sender, EventArgs e)
      {
         employeeViewModel.EmployeeCollection.Add(new Employee() { ID = 10, Name = "Bob10" });
      }

      public class Employee
      {
         private int id;
         public int ID
         {
            get { return id; }
            set { id = value; }
         }
         private string name;
         public string Name
         {
            get { return name; }
            set { name = value; }
         }
      }

      public class EmployeeViewModel : INotifyPropertyChanged
      {
         private ObservableCollection<Employee> employeeCollection;

         public event PropertyChangedEventHandler PropertyChanged;
         void OnPropertyChanged([CallerMemberName] string propertyName = "")
         {
            if (PropertyChanged == null) return;

            PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
         }
         private object selectedItem;
         public object SelectedItem
         {
            get { return selectedItem; }
            set { selectedItem = value; OnPropertyChanged(); }
         }
         public ObservableCollection<Employee> EmployeeCollection
         {
            get { return employeeCollection; }
            set { employeeCollection = value; OnPropertyChanged(); }
         }
         public EmployeeViewModel()
         {
            employeeCollection = new ObservableCollection<Employee>();
            employeeCollection.Add(new Employee() { ID = 1, Name = "Frank" });
            employeeCollection.Add(new Employee() { ID = 2, Name = "James" });
            employeeCollection.Add(new Employee() { ID = 3, Name = "Steve" });
            employeeCollection.Add(new Employee() { ID = 4, Name = "Lucas" });
            employeeCollection.Add(new Employee() { ID = 5, Name = "Mark" });
            employeeCollection.Add(new Employee() { ID = 6, Name = "Michael" });
            employeeCollection.Add(new Employee() { ID = 7, Name = "Aldrin" });
            employeeCollection.Add(new Employee() { ID = 8, Name = "Jack" });
            employeeCollection.Add(new Employee() { ID = 9, Name = "Howard" });
            SelectedItem = employeeCollection[0];
         }
      }
   }
}
